# TCL File Generated by Component Editor 22.1
# Wed Aug 30 13:59:35 CEST 2023
# DO NOT MODIFY


# 
# sdram_controller_axi4 "SDRAM Controller (AXI4)" v1.0
# Ultra-Embedded.com 2023.08.30.13:59:35
# This IP core is that of a small, simple SDRAM controller used to interface a 32-bit AXI-4 bus to a 16-bit SDRAM chip
# 

# 
# request TCL package from ACDS 16.1
# 
package require -exact qsys 16.1


# ------------------------------------------------------------------------------
# module sdram_controller_axi4
# ------------------------------------------------------------------------------
set_module_property DESCRIPTION "This IP core is that of a small, simple SDRAM controller used to interface a 32-bit AXI-4 bus to a 16-bit SDRAM chip"
set_module_property NAME sdram_controller_axi4
set_module_property VERSION 1.0
set_module_property INTERNAL false
set_module_property OPAQUE_ADDRESS_MAP true
set_module_property GROUP "Memory Interfaces and Controllers/SDRAM"
set_module_property AUTHOR Ultra-Embedded.com
set_module_property DISPLAY_NAME "SDRAM Controller (AXI4)"
set_module_property INSTANTIATE_IN_SYSTEM_MODULE true
set_module_property EDITABLE true
set_module_property VALIDATION_CALLBACK validate
set_module_property ELABORATION_CALLBACK elaborate
set_module_property REPORT_TO_TALKBACK false
set_module_property ALLOW_GREYBOX_GENERATION false
set_module_property REPORT_HIERARCHY false


# ------------------------------------------------------------------------------
# file sets
# ------------------------------------------------------------------------------
add_fileset QUARTUS_SYNTH QUARTUS_SYNTH "" ""
set_fileset_property QUARTUS_SYNTH TOP_LEVEL sdram_axi
set_fileset_property QUARTUS_SYNTH ENABLE_RELATIVE_INCLUDE_PATHS false
set_fileset_property QUARTUS_SYNTH ENABLE_FILE_OVERWRITE_MODE false
add_fileset_file sdram_axi.v VERILOG PATH sdram_axi.v TOP_LEVEL_FILE
add_fileset_file sdram_axi_core.v VERILOG PATH sdram_axi_core.v
add_fileset_file sdram_axi_pmem.v VERILOG PATH sdram_axi_pmem.v


# ------------------------------------------------------------------------------
# documentation links
# ------------------------------------------------------------------------------
add_documentation_link Source https://github.com/ultraembedded/core_sdram_axi4/


# ------------------------------------------------------------------------------
# parameters
# ------------------------------------------------------------------------------
add_parameter SDRAM_MHZ INTEGER
set_parameter_property SDRAM_MHZ DEFAULT_VALUE 50
set_parameter_property SDRAM_MHZ DISPLAY_NAME "Clock input"
set_parameter_property SDRAM_MHZ UNITS Megahertz
set_parameter_property SDRAM_MHZ ALLOWED_RANGES 0:200
set_parameter_property SDRAM_MHZ AFFECTS_GENERATION true
set_parameter_property SDRAM_MHZ HDL_PARAMETER true

add_parameter SDRAM_BANKS INTEGER
set_parameter_property SDRAM_BANKS DEFAULT_VALUE 4
set_parameter_property SDRAM_BANKS DISPLAY_NAME "Banks"
set_parameter_property SDRAM_BANKS UNITS None
set_parameter_property SDRAM_BANKS DESCRIPTION "Number of SDRAM banks"
set_parameter_property SDRAM_BANKS ALLOWED_RANGES {2 4}
set_parameter_property SDRAM_BANKS AFFECTS_GENERATION true
set_parameter_property SDRAM_BANKS HDL_PARAMETER true

add_parameter SDRAM_COL_W INTEGER
set_parameter_property SDRAM_COL_W DEFAULT_VALUE 8
set_parameter_property SDRAM_COL_W DISPLAY_NAME "Column"
set_parameter_property SDRAM_COL_W UNITS None
set_parameter_property SDRAM_COL_W DESCRIPTION "Number of column address bits"
set_parameter_property SDRAM_COL_W ALLOWED_RANGES {8 9 10 11 12 13 14}
set_parameter_property SDRAM_COL_W AFFECTS_GENERATION true
set_parameter_property SDRAM_COL_W HDL_PARAMETER true

add_parameter SDRAM_ROW_W INTEGER 
set_parameter_property SDRAM_ROW_W DEFAULT_VALUE 12
set_parameter_property SDRAM_ROW_W DISPLAY_NAME "Row"
set_parameter_property SDRAM_ROW_W UNITS None
set_parameter_property SDRAM_ROW_W DESCRIPTION "Number of row address bits"
set_parameter_property SDRAM_ROW_W ALLOWED_RANGES {11 12 13 14}
set_parameter_property SDRAM_ROW_W AFFECTS_GENERATION true
set_parameter_property SDRAM_ROW_W HDL_PARAMETER true

add_parameter SDRAM_CAS_LATENCY INTEGER
set_parameter_property SDRAM_CAS_LATENCY DEFAULT_VALUE 3
set_parameter_property SDRAM_CAS_LATENCY DISPLAY_NAME "CAS latency cycles"
set_parameter_property SDRAM_CAS_LATENCY UNITS None
set_parameter_property SDRAM_CAS_LATENCY DESCRIPTION "Latency (in clock cycles) from a read command to data out"
set_parameter_property SDRAM_CAS_LATENCY ALLOWED_RANGES {1 2 3}
set_parameter_property SDRAM_CAS_LATENCY AFFECTS_GENERATION true
set_parameter_property SDRAM_CAS_LATENCY HDL_PARAMETER true

add_parameter SDRAM_START_DELAY_US INTEGER
set_parameter_property SDRAM_START_DELAY_US DEFAULT_VALUE {200}
set_parameter_property SDRAM_START_DELAY_US DISPLAY_NAME "Delay after powerup, before initialization"
set_parameter_property SDRAM_START_DELAY_US UNITS Microseconds
set_parameter_property SDRAM_START_DELAY_US DESCRIPTION "The delay from stable clock and power to SDRAM initialization"
set_parameter_property SDRAM_START_DELAY_US ALLOWED_RANGES {0:999}
set_parameter_property SDRAM_START_DELAY_US AFFECTS_GENERATION true
set_parameter_property SDRAM_START_DELAY_US HDL_PARAMETER true

add_parameter SDRAM_REFRESH_PERIOD_US FLOAT
set_parameter_property SDRAM_REFRESH_PERIOD_US DEFAULT_VALUE {15.625}
set_parameter_property SDRAM_REFRESH_PERIOD_US DISPLAY_NAME "Issue one refresh command every"
set_parameter_property SDRAM_REFRESH_PERIOD_US UNITS Microseconds
set_parameter_property SDRAM_REFRESH_PERIOD_US DESCRIPTION "This value specifies how often the SDRAM controller refreshes the SDRAM (Auto Refresh period)"
set_parameter_property SDRAM_REFRESH_PERIOD_US ALLOWED_RANGES {0.0:156.25}
set_parameter_property SDRAM_REFRESH_PERIOD_US AFFECTS_GENERATION true
set_parameter_property SDRAM_REFRESH_PERIOD_US HDL_PARAMETER true

add_parameter SDRAM_TRCD_NS INTEGER
set_parameter_property SDRAM_TRCD_NS DEFAULT_VALUE {15}
set_parameter_property SDRAM_TRCD_NS DISPLAY_NAME "ACTIVE to READ or WRITE delay (t_rcd)"
set_parameter_property SDRAM_TRCD_NS UNITS Nanoseconds
set_parameter_property SDRAM_TRCD_NS DESCRIPTION "ACTIVE to READ or WRITE delay"
set_parameter_property SDRAM_TRCD_NS ALLOWED_RANGES {0:200}
set_parameter_property SDRAM_TRCD_NS AFFECTS_GENERATION true
set_parameter_property SDRAM_TRCD_NS HDL_PARAMETER true

add_parameter SDRAM_TRP_NS INTEGER
set_parameter_property SDRAM_TRP_NS DEFAULT_VALUE {15}
set_parameter_property SDRAM_TRP_NS DISPLAY_NAME "Duration of precharge command (t_rp)"
set_parameter_property SDRAM_TRP_NS UNITS Nanoseconds
set_parameter_property SDRAM_TRP_NS DESCRIPTION "Precharge command period"
set_parameter_property SDRAM_TRP_NS ALLOWED_RANGES {0:200}
set_parameter_property SDRAM_TRP_NS AFFECTS_GENERATION true
set_parameter_property SDRAM_TRP_NS HDL_PARAMETER true

add_parameter SDRAM_TRFC_NS INTEGER
set_parameter_property SDRAM_TRFC_NS DEFAULT_VALUE {60}
set_parameter_property SDRAM_TRFC_NS DISPLAY_NAME "Duration of refresh command (t_rfc)"
set_parameter_property SDRAM_TRFC_NS UNITS Nanoseconds
set_parameter_property SDRAM_TRFC_NS DESCRIPTION "Auto Refresh period"
set_parameter_property SDRAM_TRFC_NS ALLOWED_RANGES {0:700}
set_parameter_property SDRAM_TRFC_NS AFFECTS_GENERATION true
set_parameter_property SDRAM_TRFC_NS HDL_PARAMETER true

add_parameter SDRAM_ADDR_W INTEGER
set_parameter_property SDRAM_ADDR_W DEFAULT_VALUE 22
set_parameter_property SDRAM_ADDR_W DISPLAY_NAME SDRAM_ADDR_W
set_parameter_property SDRAM_ADDR_W UNITS None
set_parameter_property SDRAM_ADDR_W ALLOWED_RANGES 1:32
set_parameter_property SDRAM_ADDR_W DESCRIPTION ""
set_parameter_property SDRAM_ADDR_W HDL_PARAMETER true
set_parameter_property SDRAM_ADDR_W AFFECTS_GENERATION true
set_parameter_property SDRAM_ADDR_W DERIVED true
set_parameter_property SDRAM_ADDR_W ENABLED false
set_parameter_property SDRAM_ADDR_W VISIBLE false

# ------------------------------------------------------------------------------
# module GUI
# ------------------------------------------------------------------------------

# display tab Memory
add_display_item {} {Memory} GROUP tab
# group Clock
add_display_item {Memory} {Clock} GROUP
add_display_item {Clock} SDRAM_MHZ PARAMETER
# group Architecture
add_display_item {Memory} {Architecture} GROUP
add_display_item {Architecture} SDRAM_BANKS PARAMETER
# group Address Width
add_display_item {Memory} {Address Width} GROUP
add_display_item {Address Width} SDRAM_ROW_W PARAMETER
add_display_item {Address Width} SDRAM_COL_W PARAMETER

# display tab Timing
add_display_item {} {Timing} GROUP tab
add_display_item {Timing} SDRAM_CAS_LATENCY PARAMETER
add_display_item {Timing} SDRAM_START_DELAY_US PARAMETER
add_display_item {Timing} SDRAM_REFRESH_PERIOD_US PARAMETER
add_display_item {Timing} SDRAM_TRCD_NS PARAMETER
add_display_item {Timing} SDRAM_TRP_NS PARAMETER
add_display_item {Timing} SDRAM_TRFC_NS PARAMETER


# ------------------------------------------------------------------------------
# misc
# ------------------------------------------------------------------------------

# ------------------------------------------------------------------------------
# log2ceil
#
# rounded-upwards power of 2, used to determine address width need for given size
#
# args:
#   VAL   value
#
# return:
#   value of minimum width
#
proc log2ceil {VAL} {
    set res 0
    set range [ expr $VAL - 1 ]
    while { [ expr $range > 0 ] } {
        set range [ expr $range / 2 ]
        set res [ expr $res + 1 ]
    }
    return $res
}

# ------------------------------------------------------------------------------
# module validate
# ------------------------------------------------------------------------------

proc validate {} {
 	set SDRAM_COL_W   [ get_parameter_value SDRAM_COL_W ]
	set SDRAM_ROW_W   [ get_parameter_value SDRAM_ROW_W ]
	set SDRAM_BANKS   [ get_parameter_value SDRAM_BANKS ] 
	set SDRAM_BANK_W  [ log2ceil $SDRAM_BANKS ] 
  
	set_parameter_value SDRAM_ADDR_W [ expr {$SDRAM_COL_W + $SDRAM_ROW_W + $SDRAM_BANK_W + 1} ] 
  
}

# ------------------------------------------------------------------------------
# display items
# ------------------------------------------------------------------------------

proc elaborate {} {
  # ------------------------------------------------------------------------------
  # read parameter
  # ------------------------------------------------------------------------------
  set SDRAM_ADDR_W  [ get_parameter_value SDRAM_ADDR_W ]
  set SDRAM_ROW_W   [ get_parameter_value SDRAM_ROW_W ]
  set SDRAM_BANKS   [ get_parameter_value SDRAM_BANKS ]
  
  # ------------------------------------------------------------------------------
  # connection point s1
  # ------------------------------------------------------------------------------
  add_interface s1 axi4 end
  set_interface_property s1 associatedClock clk
  set_interface_property s1 associatedReset reset
  set_interface_property s1 readAcceptanceCapability 1
  set_interface_property s1 writeAcceptanceCapability 1
  set_interface_property s1 combinedAcceptanceCapability 1
  set_interface_property s1 readDataReorderingDepth 1
  set_interface_property s1 bridgesToMaster ""
  set_interface_property s1 ENABLED true
  set_interface_property s1 EXPORT_OF ""
  set_interface_property s1 PORT_NAME_MAP ""
  set_interface_property s1 CMSIS_SVD_VARIABLES ""
  set_interface_property s1 SVD_ADDRESS_GROUP ""
  
  add_interface_port s1 inport_awvalid_i awvalid Input 1
  add_interface_port s1 inport_awaddr_i awaddr Input "$SDRAM_ADDR_W"
  add_interface_port s1 inport_awid_i awid Input 4
  add_interface_port s1 inport_awlen_i awlen Input 8
  add_interface_port s1 inport_awburst_i awburst Input 2
  add_interface_port s1 inport_wvalid_i wvalid Input 1
  add_interface_port s1 inport_wdata_i wdata Input 32
  add_interface_port s1 inport_wstrb_i wstrb Input 4
  add_interface_port s1 inport_wlast_i wlast Input 1
  add_interface_port s1 inport_bready_i bready Input 1
  add_interface_port s1 inport_arvalid_i arvalid Input 1
  add_interface_port s1 inport_araddr_i araddr Input "$SDRAM_ADDR_W"
  add_interface_port s1 inport_arid_i arid Input 4
  add_interface_port s1 inport_arlen_i arlen Input 8
  add_interface_port s1 inport_arburst_i arburst Input 2
  add_interface_port s1 inport_rready_i rready Input 1
  add_interface_port s1 inport_awready_o awready Output 1
  add_interface_port s1 inport_wready_o wready Output 1
  add_interface_port s1 inport_bvalid_o bvalid Output 1
  add_interface_port s1 inport_bresp_o bresp Output 2
  add_interface_port s1 inport_bid_o bid Output 4
  add_interface_port s1 inport_arready_o arready Output 1
  add_interface_port s1 inport_rvalid_o rvalid Output 1
  add_interface_port s1 inport_rdata_o rdata Output 32
  add_interface_port s1 inport_rresp_o rresp Output 2
  add_interface_port s1 inport_rid_o rid Output 4
  add_interface_port s1 inport_rlast_o rlast Output 1
  add_interface_port s1 inport_arsize_i arsize Input 3
  add_interface_port s1 inport_awsize_i awsize Input 3
  set_interface_assignment s1 embeddedsw.configuration.isFlash 0
  set_interface_assignment s1 embeddedsw.configuration.isMemoryDevice 1
  set_interface_assignment s1 embeddedsw.configuration.isNonVolatileStorage 0
  set_interface_assignment s1 embeddedsw.configuration.isPrintableDevice 0
  
  
  # ------------------------------------------------------------------------------
  # connection point clk
  # ------------------------------------------------------------------------------
  add_interface clk clock end
  set_interface_property clk clockRate 0
  set_interface_property clk ENABLED true
  set_interface_property clk EXPORT_OF ""
  set_interface_property clk PORT_NAME_MAP ""
  set_interface_property clk CMSIS_SVD_VARIABLES ""
  set_interface_property clk SVD_ADDRESS_GROUP ""
  
  add_interface_port clk clk_i clk Input 1
  
  
  # ------------------------------------------------------------------------------
  # connection point reset
  # ------------------------------------------------------------------------------
  add_interface reset reset end
  set_interface_property reset associatedClock clk
  set_interface_property reset synchronousEdges DEASSERT
  set_interface_property reset ENABLED true
  set_interface_property reset EXPORT_OF ""
  set_interface_property reset PORT_NAME_MAP ""
  set_interface_property reset CMSIS_SVD_VARIABLES ""
  set_interface_property reset SVD_ADDRESS_GROUP ""
  
  add_interface_port reset rst_i reset Input 1
  
  
  # ------------------------------------------------------------------------------
  # connection point wire
  # ------------------------------------------------------------------------------
  add_interface wire conduit end
  set_interface_property wire associatedClock clk
  set_interface_property wire associatedReset reset
  set_interface_property wire ENABLED true
  set_interface_property wire EXPORT_OF ""
  set_interface_property wire PORT_NAME_MAP ""
  set_interface_property wire CMSIS_SVD_VARIABLES ""
  set_interface_property wire SVD_ADDRESS_GROUP ""
  
  add_interface_port wire sdram_addr_o sdram_addr Output "$SDRAM_ROW_W"
  add_interface_port wire sdram_ba_o sdram_ba Output "[ log2ceil $SDRAM_BANKS ]"
  add_interface_port wire sdram_cas_o sdram_cas Output 1
  add_interface_port wire sdram_cke_o sdram_cke Output 1
  add_interface_port wire sdram_clk_o sdram_clk Output 1
  add_interface_port wire sdram_cs_o sdram_cs Output 1
  add_interface_port wire sdram_dqm_o sdram_dqm Output 2
  add_interface_port wire sdram_ras_o sdram_ras Output 1
  add_interface_port wire sdram_we_o sdram_we Output 1
  add_interface_port wire sdram_dq_io sdram_dq Bidir 16

}
