# qsys scripting (.tcl) file for nios_test_board
package require -exact qsys 16.0
# #TE_MOD#_Add next line 
set arg [split $::args "|"]
# #TE_MOD#_Add next line 
set ::device [lindex $arg 0]
# #TE_MOD#_Add next line 
set ::device_family [lindex $arg 1]
# #TE_MOD#_Add next line 
set ::ddr_device [lindex $arg 2]
# #TE_MOD#_Add next line 
set ::sdk_name [lindex $arg 3]

create_system {nios_test_board}

# #TE_MOD# set_project_property DEVICE_FAMILY {Cyclone V} 
# #TE_MOD#_Add next line 
set_project_property DEVICE_FAMILY $::device_family
# #TE_MOD# set_project_property DEVICE {5CEBA2U15C8} 
# #TE_MOD#_Add next line 
set_project_property DEVICE $::device
set_project_property HIDE_FROM_IP_CATALOG {false}

# Instances and instance parameters
# (disabled instances are intentionally culled)
add_instance clk_0 clock_source
set_instance_parameter_value clk_0 {clockFrequency} {50000000.0}
set_instance_parameter_value clk_0 {clockFrequencyKnown} {1}
set_instance_parameter_value clk_0 {resetSynchronousEdges} {NONE}

add_instance config_flash intel_generic_serial_flash_interface_top
set_instance_parameter_value config_flash {CHIP_SELECT_BYPASS} {0}
set_instance_parameter_value config_flash {CHIP_SELS} {1}
set_instance_parameter_value config_flash {DEBUG_OPTION} {0}
set_instance_parameter_value config_flash {DEFAULT_VALUE_REG_0} {1}
set_instance_parameter_value config_flash {DEFAULT_VALUE_REG_1} {1}
set_instance_parameter_value config_flash {DEFAULT_VALUE_REG_2} {0}
set_instance_parameter_value config_flash {DEFAULT_VALUE_REG_3} {0}
set_instance_parameter_value config_flash {DEFAULT_VALUE_REG_4} {0}
set_instance_parameter_value config_flash {DEFAULT_VALUE_REG_5} {3}
set_instance_parameter_value config_flash {DEFAULT_VALUE_REG_6} {1282}
set_instance_parameter_value config_flash {DEFAULT_VALUE_REG_7} {6149}
set_instance_parameter_value config_flash {DEVICE_DENSITY} {64}
set_instance_parameter_value config_flash {ENABLE_SIM_MODEL} {0}
set_instance_parameter_value config_flash {PIPE_CMD_GEN_CMD} {0}
set_instance_parameter_value config_flash {PIPE_CSR} {0}
set_instance_parameter_value config_flash {PIPE_MUX_CMD} {0}
set_instance_parameter_value config_flash {PIPE_XIP} {0}
set_instance_parameter_value config_flash {USE_CHIP_SEL_FROM_CSR} {1}
set_instance_parameter_value config_flash {gui_use_asmiblock} {0}
set_instance_parameter_value config_flash {gui_use_csr_byteenable} {0}
set_instance_parameter_value config_flash {gui_use_gpio} {0}

add_instance niosv_m intel_niosv_m
set_instance_parameter_value niosv_m {enableDebug} {1}
set_instance_parameter_value niosv_m {enableDebugReset} {0}
set_instance_parameter_value niosv_m {enableECCLite} {0}
set_instance_parameter_value niosv_m {numGpr} {32}
set_instance_parameter_value niosv_m {pipelineArch} {1}
set_instance_parameter_value niosv_m {resetOffset} {1048576}
set_instance_parameter_value niosv_m {resetSlave} {config_flash.avl_mem}
set_instance_parameter_value niosv_m {useResetReq} {0}

add_instance pio_sel altera_avalon_pio
set_instance_parameter_value pio_sel {bitClearingEdgeCapReg} {0}
set_instance_parameter_value pio_sel {bitModifyingOutReg} {0}
set_instance_parameter_value pio_sel {captureEdge} {0}
set_instance_parameter_value pio_sel {direction} {Input}
set_instance_parameter_value pio_sel {edgeType} {RISING}
set_instance_parameter_value pio_sel {generateIRQ} {0}
set_instance_parameter_value pio_sel {irqType} {LEVEL}
set_instance_parameter_value pio_sel {resetValue} {0.0}
set_instance_parameter_value pio_sel {simDoTestBenchWiring} {0}
set_instance_parameter_value pio_sel {simDrivenValue} {0.0}
set_instance_parameter_value pio_sel {width} {4}

add_instance pll altera_pll
set_instance_parameter_value pll {debug_print_output} {0}
set_instance_parameter_value pll {debug_use_rbc_taf_method} {0}
set_instance_parameter_value pll {gui_active_clk} {0}
set_instance_parameter_value pll {gui_actual_output_clock_frequency0} {0 MHz}
set_instance_parameter_value pll {gui_actual_output_clock_frequency1} {0 MHz}
set_instance_parameter_value pll {gui_actual_output_clock_frequency10} {0 MHz}
set_instance_parameter_value pll {gui_actual_output_clock_frequency11} {0 MHz}
set_instance_parameter_value pll {gui_actual_output_clock_frequency12} {0 MHz}
set_instance_parameter_value pll {gui_actual_output_clock_frequency13} {0 MHz}
set_instance_parameter_value pll {gui_actual_output_clock_frequency14} {0 MHz}
set_instance_parameter_value pll {gui_actual_output_clock_frequency15} {0 MHz}
set_instance_parameter_value pll {gui_actual_output_clock_frequency16} {0 MHz}
set_instance_parameter_value pll {gui_actual_output_clock_frequency17} {0 MHz}
set_instance_parameter_value pll {gui_actual_output_clock_frequency2} {0 MHz}
set_instance_parameter_value pll {gui_actual_output_clock_frequency3} {0 MHz}
set_instance_parameter_value pll {gui_actual_output_clock_frequency4} {0 MHz}
set_instance_parameter_value pll {gui_actual_output_clock_frequency5} {0 MHz}
set_instance_parameter_value pll {gui_actual_output_clock_frequency6} {0 MHz}
set_instance_parameter_value pll {gui_actual_output_clock_frequency7} {0 MHz}
set_instance_parameter_value pll {gui_actual_output_clock_frequency8} {0 MHz}
set_instance_parameter_value pll {gui_actual_output_clock_frequency9} {0 MHz}
set_instance_parameter_value pll {gui_actual_phase_shift0} {0}
set_instance_parameter_value pll {gui_actual_phase_shift1} {0}
set_instance_parameter_value pll {gui_actual_phase_shift10} {0}
set_instance_parameter_value pll {gui_actual_phase_shift11} {0}
set_instance_parameter_value pll {gui_actual_phase_shift12} {0}
set_instance_parameter_value pll {gui_actual_phase_shift13} {0}
set_instance_parameter_value pll {gui_actual_phase_shift14} {0}
set_instance_parameter_value pll {gui_actual_phase_shift15} {0}
set_instance_parameter_value pll {gui_actual_phase_shift16} {0}
set_instance_parameter_value pll {gui_actual_phase_shift17} {0}
set_instance_parameter_value pll {gui_actual_phase_shift2} {0}
set_instance_parameter_value pll {gui_actual_phase_shift3} {0}
set_instance_parameter_value pll {gui_actual_phase_shift4} {0}
set_instance_parameter_value pll {gui_actual_phase_shift5} {0}
set_instance_parameter_value pll {gui_actual_phase_shift6} {0}
set_instance_parameter_value pll {gui_actual_phase_shift7} {0}
set_instance_parameter_value pll {gui_actual_phase_shift8} {0}
set_instance_parameter_value pll {gui_actual_phase_shift9} {0}
set_instance_parameter_value pll {gui_cascade_counter0} {0}
set_instance_parameter_value pll {gui_cascade_counter1} {0}
set_instance_parameter_value pll {gui_cascade_counter10} {0}
set_instance_parameter_value pll {gui_cascade_counter11} {0}
set_instance_parameter_value pll {gui_cascade_counter12} {0}
set_instance_parameter_value pll {gui_cascade_counter13} {0}
set_instance_parameter_value pll {gui_cascade_counter14} {0}
set_instance_parameter_value pll {gui_cascade_counter15} {0}
set_instance_parameter_value pll {gui_cascade_counter16} {0}
set_instance_parameter_value pll {gui_cascade_counter17} {0}
set_instance_parameter_value pll {gui_cascade_counter2} {0}
set_instance_parameter_value pll {gui_cascade_counter3} {0}
set_instance_parameter_value pll {gui_cascade_counter4} {0}
set_instance_parameter_value pll {gui_cascade_counter5} {0}
set_instance_parameter_value pll {gui_cascade_counter6} {0}
set_instance_parameter_value pll {gui_cascade_counter7} {0}
set_instance_parameter_value pll {gui_cascade_counter8} {0}
set_instance_parameter_value pll {gui_cascade_counter9} {0}
set_instance_parameter_value pll {gui_cascade_outclk_index} {0}
set_instance_parameter_value pll {gui_channel_spacing} {0.0}
set_instance_parameter_value pll {gui_clk_bad} {0}
set_instance_parameter_value pll {gui_device_speed_grade} {1}
set_instance_parameter_value pll {gui_divide_factor_c0} {1}
set_instance_parameter_value pll {gui_divide_factor_c1} {1}
set_instance_parameter_value pll {gui_divide_factor_c10} {1}
set_instance_parameter_value pll {gui_divide_factor_c11} {1}
set_instance_parameter_value pll {gui_divide_factor_c12} {1}
set_instance_parameter_value pll {gui_divide_factor_c13} {1}
set_instance_parameter_value pll {gui_divide_factor_c14} {1}
set_instance_parameter_value pll {gui_divide_factor_c15} {1}
set_instance_parameter_value pll {gui_divide_factor_c16} {1}
set_instance_parameter_value pll {gui_divide_factor_c17} {1}
set_instance_parameter_value pll {gui_divide_factor_c2} {1}
set_instance_parameter_value pll {gui_divide_factor_c3} {1}
set_instance_parameter_value pll {gui_divide_factor_c4} {1}
set_instance_parameter_value pll {gui_divide_factor_c5} {1}
set_instance_parameter_value pll {gui_divide_factor_c6} {1}
set_instance_parameter_value pll {gui_divide_factor_c7} {1}
set_instance_parameter_value pll {gui_divide_factor_c8} {1}
set_instance_parameter_value pll {gui_divide_factor_c9} {1}
set_instance_parameter_value pll {gui_divide_factor_n} {1}
set_instance_parameter_value pll {gui_dps_cntr} {C0}
set_instance_parameter_value pll {gui_dps_dir} {Positive}
set_instance_parameter_value pll {gui_dps_num} {1}
set_instance_parameter_value pll {gui_dsm_out_sel} {1st_order}
set_instance_parameter_value pll {gui_duty_cycle0} {50}
set_instance_parameter_value pll {gui_duty_cycle1} {50}
set_instance_parameter_value pll {gui_duty_cycle10} {50}
set_instance_parameter_value pll {gui_duty_cycle11} {50}
set_instance_parameter_value pll {gui_duty_cycle12} {50}
set_instance_parameter_value pll {gui_duty_cycle13} {50}
set_instance_parameter_value pll {gui_duty_cycle14} {50}
set_instance_parameter_value pll {gui_duty_cycle15} {50}
set_instance_parameter_value pll {gui_duty_cycle16} {50}
set_instance_parameter_value pll {gui_duty_cycle17} {50}
set_instance_parameter_value pll {gui_duty_cycle2} {50}
set_instance_parameter_value pll {gui_duty_cycle3} {50}
set_instance_parameter_value pll {gui_duty_cycle4} {50}
set_instance_parameter_value pll {gui_duty_cycle5} {50}
set_instance_parameter_value pll {gui_duty_cycle6} {50}
set_instance_parameter_value pll {gui_duty_cycle7} {50}
set_instance_parameter_value pll {gui_duty_cycle8} {50}
set_instance_parameter_value pll {gui_duty_cycle9} {50}
set_instance_parameter_value pll {gui_en_adv_params} {0}
set_instance_parameter_value pll {gui_en_dps_ports} {0}
set_instance_parameter_value pll {gui_en_phout_ports} {0}
set_instance_parameter_value pll {gui_en_reconf} {0}
set_instance_parameter_value pll {gui_enable_cascade_in} {0}
set_instance_parameter_value pll {gui_enable_cascade_out} {0}
set_instance_parameter_value pll {gui_enable_mif_dps} {0}
set_instance_parameter_value pll {gui_feedback_clock} {Global Clock}
set_instance_parameter_value pll {gui_frac_multiply_factor} {1.0}
set_instance_parameter_value pll {gui_fractional_cout} {32}
set_instance_parameter_value pll {gui_mif_generate} {0}
set_instance_parameter_value pll {gui_multiply_factor} {1}
set_instance_parameter_value pll {gui_number_of_clocks} {1}
set_instance_parameter_value pll {gui_operation_mode} {direct}
set_instance_parameter_value pll {gui_output_clock_frequency0} {100.0}
set_instance_parameter_value pll {gui_output_clock_frequency1} {100.0}
set_instance_parameter_value pll {gui_output_clock_frequency10} {100.0}
set_instance_parameter_value pll {gui_output_clock_frequency11} {100.0}
set_instance_parameter_value pll {gui_output_clock_frequency12} {100.0}
set_instance_parameter_value pll {gui_output_clock_frequency13} {100.0}
set_instance_parameter_value pll {gui_output_clock_frequency14} {100.0}
set_instance_parameter_value pll {gui_output_clock_frequency15} {100.0}
set_instance_parameter_value pll {gui_output_clock_frequency16} {100.0}
set_instance_parameter_value pll {gui_output_clock_frequency17} {100.0}
set_instance_parameter_value pll {gui_output_clock_frequency2} {100.0}
set_instance_parameter_value pll {gui_output_clock_frequency3} {100.0}
set_instance_parameter_value pll {gui_output_clock_frequency4} {100.0}
set_instance_parameter_value pll {gui_output_clock_frequency5} {100.0}
set_instance_parameter_value pll {gui_output_clock_frequency6} {100.0}
set_instance_parameter_value pll {gui_output_clock_frequency7} {100.0}
set_instance_parameter_value pll {gui_output_clock_frequency8} {100.0}
set_instance_parameter_value pll {gui_output_clock_frequency9} {100.0}
set_instance_parameter_value pll {gui_phase_shift0} {0}
set_instance_parameter_value pll {gui_phase_shift1} {0}
set_instance_parameter_value pll {gui_phase_shift10} {0}
set_instance_parameter_value pll {gui_phase_shift11} {0}
set_instance_parameter_value pll {gui_phase_shift12} {0}
set_instance_parameter_value pll {gui_phase_shift13} {0}
set_instance_parameter_value pll {gui_phase_shift14} {0}
set_instance_parameter_value pll {gui_phase_shift15} {0}
set_instance_parameter_value pll {gui_phase_shift16} {0}
set_instance_parameter_value pll {gui_phase_shift17} {0}
set_instance_parameter_value pll {gui_phase_shift2} {0}
set_instance_parameter_value pll {gui_phase_shift3} {0}
set_instance_parameter_value pll {gui_phase_shift4} {0}
set_instance_parameter_value pll {gui_phase_shift5} {0}
set_instance_parameter_value pll {gui_phase_shift6} {0}
set_instance_parameter_value pll {gui_phase_shift7} {0}
set_instance_parameter_value pll {gui_phase_shift8} {0}
set_instance_parameter_value pll {gui_phase_shift9} {0}
set_instance_parameter_value pll {gui_phase_shift_deg0} {0.0}
set_instance_parameter_value pll {gui_phase_shift_deg1} {0.0}
set_instance_parameter_value pll {gui_phase_shift_deg10} {0.0}
set_instance_parameter_value pll {gui_phase_shift_deg11} {0.0}
set_instance_parameter_value pll {gui_phase_shift_deg12} {0.0}
set_instance_parameter_value pll {gui_phase_shift_deg13} {0.0}
set_instance_parameter_value pll {gui_phase_shift_deg14} {0.0}
set_instance_parameter_value pll {gui_phase_shift_deg15} {0.0}
set_instance_parameter_value pll {gui_phase_shift_deg16} {0.0}
set_instance_parameter_value pll {gui_phase_shift_deg17} {0.0}
set_instance_parameter_value pll {gui_phase_shift_deg2} {0.0}
set_instance_parameter_value pll {gui_phase_shift_deg3} {0.0}
set_instance_parameter_value pll {gui_phase_shift_deg4} {0.0}
set_instance_parameter_value pll {gui_phase_shift_deg5} {0.0}
set_instance_parameter_value pll {gui_phase_shift_deg6} {0.0}
set_instance_parameter_value pll {gui_phase_shift_deg7} {0.0}
set_instance_parameter_value pll {gui_phase_shift_deg8} {0.0}
set_instance_parameter_value pll {gui_phase_shift_deg9} {0.0}
set_instance_parameter_value pll {gui_phout_division} {1}
set_instance_parameter_value pll {gui_pll_auto_reset} {Off}
set_instance_parameter_value pll {gui_pll_bandwidth_preset} {Auto}
set_instance_parameter_value pll {gui_pll_cascading_mode} {Create an adjpllin signal to connect with an upstream PLL}
set_instance_parameter_value pll {gui_pll_mode} {Integer-N PLL}
set_instance_parameter_value pll {gui_ps_units0} {degrees}
set_instance_parameter_value pll {gui_ps_units1} {ps}
set_instance_parameter_value pll {gui_ps_units10} {ps}
set_instance_parameter_value pll {gui_ps_units11} {ps}
set_instance_parameter_value pll {gui_ps_units12} {ps}
set_instance_parameter_value pll {gui_ps_units13} {ps}
set_instance_parameter_value pll {gui_ps_units14} {ps}
set_instance_parameter_value pll {gui_ps_units15} {ps}
set_instance_parameter_value pll {gui_ps_units16} {ps}
set_instance_parameter_value pll {gui_ps_units17} {ps}
set_instance_parameter_value pll {gui_ps_units2} {ps}
set_instance_parameter_value pll {gui_ps_units3} {ps}
set_instance_parameter_value pll {gui_ps_units4} {ps}
set_instance_parameter_value pll {gui_ps_units5} {ps}
set_instance_parameter_value pll {gui_ps_units6} {ps}
set_instance_parameter_value pll {gui_ps_units7} {ps}
set_instance_parameter_value pll {gui_ps_units8} {ps}
set_instance_parameter_value pll {gui_ps_units9} {ps}
set_instance_parameter_value pll {gui_refclk1_frequency} {100.0}
set_instance_parameter_value pll {gui_refclk_switch} {0}
set_instance_parameter_value pll {gui_reference_clock_frequency} {12.0}
set_instance_parameter_value pll {gui_switchover_delay} {0}
set_instance_parameter_value pll {gui_switchover_mode} {Automatic Switchover}
set_instance_parameter_value pll {gui_use_locked} {0}

add_instance sdram_controller sdram_controller_axi4
# #TE_MOD#_Add next line 
apply_preset sdram_controller "$::ddr_device"
# #TE_MOD# set_instance_parameter_value sdram_controller {SDRAM_BANKS} {4} 
# #TE_MOD# set_instance_parameter_value sdram_controller {SDRAM_CAS_LATENCY} {3} 
# #TE_MOD# set_instance_parameter_value sdram_controller {SDRAM_COL_W} {8} 
# #TE_MOD# set_instance_parameter_value sdram_controller {SDRAM_MHZ} {100} 
# #TE_MOD# set_instance_parameter_value sdram_controller {SDRAM_REFRESH_PERIOD_US} {15.625} 
# #TE_MOD# set_instance_parameter_value sdram_controller {SDRAM_ROW_W} {12} 
# #TE_MOD# set_instance_parameter_value sdram_controller {SDRAM_START_DELAY_US} {200} 
# #TE_MOD# set_instance_parameter_value sdram_controller {SDRAM_TRCD_NS} {20} 
# #TE_MOD# set_instance_parameter_value sdram_controller {SDRAM_TRFC_NS} {70} 
# #TE_MOD# set_instance_parameter_value sdram_controller {SDRAM_TRP_NS} {20} 

add_instance uart altera_avalon_uart
set_instance_parameter_value uart {baud} {115200}
set_instance_parameter_value uart {dataBits} {8}
set_instance_parameter_value uart {fixedBaud} {1}
set_instance_parameter_value uart {parity} {NONE}
set_instance_parameter_value uart {simCharStream} {}
set_instance_parameter_value uart {simInteractiveInputEnable} {0}
set_instance_parameter_value uart {simInteractiveOutputEnable} {0}
set_instance_parameter_value uart {simTrueBaud} {0}
set_instance_parameter_value uart {stopBits} {1}
set_instance_parameter_value uart {syncRegDepth} {2}
set_instance_parameter_value uart {useCtsRts} {0}
set_instance_parameter_value uart {useEopRegister} {0}
set_instance_parameter_value uart {useRelativePathForSimFile} {0}

# exported interfaces
add_interface clk clock sink
set_interface_property clk EXPORT_OF clk_0.clk_in
add_interface pio_sel conduit end
set_interface_property pio_sel EXPORT_OF pio_sel.external_connection
add_interface reset reset sink
set_interface_property reset EXPORT_OF clk_0.clk_in_reset
add_interface sdram_controller conduit end
set_interface_property sdram_controller EXPORT_OF sdram_controller.wire
add_interface uart conduit end
set_interface_property uart EXPORT_OF uart.external_connection

# connections and connection parameters
add_connection clk_0.clk pll.refclk

add_connection clk_0.clk_reset config_flash.reset

add_connection clk_0.clk_reset niosv_m.reset

add_connection clk_0.clk_reset pio_sel.reset

add_connection clk_0.clk_reset pll.reset

add_connection clk_0.clk_reset sdram_controller.reset

add_connection clk_0.clk_reset uart.reset

add_connection niosv_m.data_manager config_flash.avl_csr
set_connection_parameter_value niosv_m.data_manager/config_flash.avl_csr arbitrationPriority {1}
set_connection_parameter_value niosv_m.data_manager/config_flash.avl_csr baseAddress {0x01010000}
set_connection_parameter_value niosv_m.data_manager/config_flash.avl_csr defaultConnection {0}

add_connection niosv_m.data_manager config_flash.avl_mem
set_connection_parameter_value niosv_m.data_manager/config_flash.avl_mem arbitrationPriority {1}
set_connection_parameter_value niosv_m.data_manager/config_flash.avl_mem baseAddress {0x00800000}
set_connection_parameter_value niosv_m.data_manager/config_flash.avl_mem defaultConnection {0}

add_connection niosv_m.data_manager niosv_m.dm_agent
set_connection_parameter_value niosv_m.data_manager/niosv_m.dm_agent arbitrationPriority {1}
set_connection_parameter_value niosv_m.data_manager/niosv_m.dm_agent baseAddress {0x01000000}
set_connection_parameter_value niosv_m.data_manager/niosv_m.dm_agent defaultConnection {0}

add_connection niosv_m.data_manager niosv_m.timer_sw_agent
set_connection_parameter_value niosv_m.data_manager/niosv_m.timer_sw_agent arbitrationPriority {1}
set_connection_parameter_value niosv_m.data_manager/niosv_m.timer_sw_agent baseAddress {0x01010140}
set_connection_parameter_value niosv_m.data_manager/niosv_m.timer_sw_agent defaultConnection {0}

add_connection niosv_m.data_manager pio_sel.s1
set_connection_parameter_value niosv_m.data_manager/pio_sel.s1 arbitrationPriority {1}
set_connection_parameter_value niosv_m.data_manager/pio_sel.s1 baseAddress {0x01010120}
set_connection_parameter_value niosv_m.data_manager/pio_sel.s1 defaultConnection {0}

add_connection niosv_m.data_manager sdram_controller.s1
set_connection_parameter_value niosv_m.data_manager/sdram_controller.s1 arbitrationPriority {1}
set_connection_parameter_value niosv_m.data_manager/sdram_controller.s1 baseAddress {0x0000}
set_connection_parameter_value niosv_m.data_manager/sdram_controller.s1 defaultConnection {0}

add_connection niosv_m.data_manager uart.s1
set_connection_parameter_value niosv_m.data_manager/uart.s1 arbitrationPriority {1}
set_connection_parameter_value niosv_m.data_manager/uart.s1 baseAddress {0x01010100}
set_connection_parameter_value niosv_m.data_manager/uart.s1 defaultConnection {0}

add_connection niosv_m.instruction_manager config_flash.avl_csr
set_connection_parameter_value niosv_m.instruction_manager/config_flash.avl_csr arbitrationPriority {1}
set_connection_parameter_value niosv_m.instruction_manager/config_flash.avl_csr baseAddress {0x01010000}
set_connection_parameter_value niosv_m.instruction_manager/config_flash.avl_csr defaultConnection {0}

add_connection niosv_m.instruction_manager config_flash.avl_mem
set_connection_parameter_value niosv_m.instruction_manager/config_flash.avl_mem arbitrationPriority {1}
set_connection_parameter_value niosv_m.instruction_manager/config_flash.avl_mem baseAddress {0x00800000}
set_connection_parameter_value niosv_m.instruction_manager/config_flash.avl_mem defaultConnection {0}

add_connection niosv_m.instruction_manager niosv_m.dm_agent
set_connection_parameter_value niosv_m.instruction_manager/niosv_m.dm_agent arbitrationPriority {1}
set_connection_parameter_value niosv_m.instruction_manager/niosv_m.dm_agent baseAddress {0x01000000}
set_connection_parameter_value niosv_m.instruction_manager/niosv_m.dm_agent defaultConnection {0}

add_connection niosv_m.instruction_manager pio_sel.s1
set_connection_parameter_value niosv_m.instruction_manager/pio_sel.s1 arbitrationPriority {1}
set_connection_parameter_value niosv_m.instruction_manager/pio_sel.s1 baseAddress {0x01010120}
set_connection_parameter_value niosv_m.instruction_manager/pio_sel.s1 defaultConnection {0}

add_connection niosv_m.instruction_manager sdram_controller.s1
set_connection_parameter_value niosv_m.instruction_manager/sdram_controller.s1 arbitrationPriority {1}
set_connection_parameter_value niosv_m.instruction_manager/sdram_controller.s1 baseAddress {0x0000}
set_connection_parameter_value niosv_m.instruction_manager/sdram_controller.s1 defaultConnection {0}

add_connection niosv_m.instruction_manager uart.s1
set_connection_parameter_value niosv_m.instruction_manager/uart.s1 arbitrationPriority {1}
set_connection_parameter_value niosv_m.instruction_manager/uart.s1 baseAddress {0x01010100}
set_connection_parameter_value niosv_m.instruction_manager/uart.s1 defaultConnection {0}

add_connection niosv_m.platform_irq_rx uart.irq
set_connection_parameter_value niosv_m.platform_irq_rx/uart.irq irqNumber {0}

add_connection pll.outclk0 config_flash.clk

add_connection pll.outclk0 niosv_m.clk

add_connection pll.outclk0 pio_sel.clk

add_connection pll.outclk0 sdram_controller.clk

add_connection pll.outclk0 uart.clk

# interconnect requirements
set_interconnect_requirement {$system} {qsys_mm.clockCrossingAdapter} {HANDSHAKE}
set_interconnect_requirement {$system} {qsys_mm.enableEccProtection} {FALSE}
set_interconnect_requirement {$system} {qsys_mm.insertDefaultSlave} {FALSE}
set_interconnect_requirement {$system} {qsys_mm.maxAdditionalLatency} {1}
# #TE_MOD#_Add next line 
auto_assign_system_base_addresses

save_system {nios_test_board.qsys}


