# Copyright (C) 2024  Intel Corporation. All rights reserved.
# Your use of Intel Corporation's design tools, logic functions 
# and other software and tools, and any partner logic 
# functions, and any output files from any of the foregoing 
# (including device programming or simulation files), and any 
# associated documentation or information are expressly subject 
# to the terms and conditions of the Intel Program License 
# Subscription Agreement, the Intel Quartus Prime License Agreement,
# the Intel FPGA IP License Agreement, or other applicable license
# agreement, including, without limitation, that your use is for
# the sole purpose of programming logic devices manufactured by
# Intel and sold by Intel or its authorized distributors.  Please
# refer to the applicable agreement for further details, at
# https://fpgasoftware.intel.com/eula.

# Quartus Prime: Generate Tcl File for Project
# File: test_board.tcl
# Generated on: Thu Aug  8 13:14:38 2024

# Load Quartus Prime Tcl Project package
package require ::quartus::project

set need_to_close_project 0
set make_assignments 1

# Check that the right project is open
if {[is_project_open]} {
	if {[string compare $quartus(project) "test_board"]} {
		puts "Project test_board is not open"
		set make_assignments 0
	}
} else {
	# Only open if not already open
	if {[project_exists test_board]} {
		project_open -revision test_board test_board
	} else {
		project_new -revision test_board test_board
	}
	set need_to_close_project 1
}

# Make assignments
if {$make_assignments} {
# #TE_MOD# 	set_global_assignment -name FAMILY "Cyclone V" 
# #TE_MOD# 	set_global_assignment -name DEVICE 5CEBA2U15C8 
	set_global_assignment -name ORIGINAL_QUARTUS_VERSION 23.1STD.1
	set_global_assignment -name PROJECT_CREATION_TIME_DATE "16:23:27  AUGUST 02, 2024"
	set_global_assignment -name LAST_QUARTUS_VERSION "23.1std.1 Lite Edition"
	set_global_assignment -name PROJECT_OUTPUT_DIRECTORY output_files
	set_global_assignment -name ERROR_CHECK_FREQUENCY_DIVISOR 256
	set_global_assignment -name POWER_PRESET_COOLING_SOLUTION "23 MM HEAT SINK WITH 200 LFPM AIRFLOW"
	set_global_assignment -name POWER_BOARD_THERMAL_MODEL "NONE (CONSERVATIVE)"
	set_global_assignment -name PARTITION_NETLIST_TYPE SOURCE -section_id Top
	set_global_assignment -name PARTITION_FITTER_PRESERVATION_LEVEL PLACEMENT_AND_ROUTING -section_id Top
	set_global_assignment -name PARTITION_COLOR 16764057 -section_id Top
	set_global_assignment -name ENABLE_OCT_DONE OFF
	set_global_assignment -name ENABLE_CONFIGURATION_PINS OFF
	set_global_assignment -name ENABLE_BOOT_SEL_PIN OFF
	set_global_assignment -name STRATIXV_CONFIGURATION_SCHEME "ACTIVE SERIAL X1"
	set_global_assignment -name USE_CONFIGURATION_DEVICE ON
	set_global_assignment -name CRC_ERROR_OPEN_DRAIN ON
	set_global_assignment -name OUTPUT_IO_TIMING_NEAR_END_VMEAS "HALF VCCIO" -rise
	set_global_assignment -name OUTPUT_IO_TIMING_NEAR_END_VMEAS "HALF VCCIO" -fall
	set_global_assignment -name OUTPUT_IO_TIMING_FAR_END_VMEAS "HALF SIGNAL SWING" -rise
	set_global_assignment -name OUTPUT_IO_TIMING_FAR_END_VMEAS "HALF SIGNAL SWING" -fall
	set_global_assignment -name ACTIVE_SERIAL_CLOCK FREQ_100MHZ
	set_global_assignment -name SDC_FILE HDL/test_board.out.sdc
	set_global_assignment -name QSYS_FILE nios_test_board.qsys
	set_global_assignment -name VHDL_FILE HDL/shift_reg_seq.vhd
	set_global_assignment -name VHDL_FILE HDL/pwm_seq.vhd
	set_global_assignment -name VHDL_FILE HDL/knightrider.vhd
	set_global_assignment -name VHDL_FILE HDL/control_mux.vhd
	set_global_assignment -name VHDL_FILE HDL/case_state_seq.vhd
	set_global_assignment -name BDF_FILE test_board.bdf
	set_location_assignment PIN_F14 -to CLK12M
	set_location_assignment PIN_P4 -to LED0
	set_location_assignment PIN_M4 -to LED1
	set_location_assignment PIN_M3 -to LED2
	set_location_assignment PIN_N3 -to LED3
	set_location_assignment PIN_V2 -to LED4
	set_location_assignment PIN_T2 -to LED5
	set_location_assignment PIN_L1 -to LED6
	set_location_assignment PIN_K1 -to LED7
	set_location_assignment PIN_L17 -to USER_BTN
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to USER_BTN
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to LED7
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to LED6
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to LED5
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to LED4
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to LED3
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to LED2
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to LED1
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to LED0
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to CLK12M
	set_location_assignment PIN_P15 -to A[11]
	set_location_assignment PIN_M13 -to A[10]
	set_location_assignment PIN_T15 -to A[9]
	set_location_assignment PIN_P14 -to A[8]
	set_location_assignment PIN_U15 -to A[7]
	set_location_assignment PIN_T16 -to A[6]
	set_location_assignment PIN_V16 -to A[5]
	set_location_assignment PIN_V15 -to A[4]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to WE
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to A[11]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to A[10]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to A[9]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to A[8]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to A[7]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to A[6]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to A[5]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to A[4]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to A[3]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to A[2]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to A[1]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to A[0]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to altera_reserved_tck
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to altera_reserved_tdi
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to altera_reserved_tdo
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to altera_reserved_tms
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to BA[1]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to BA[0]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to BDBUS0
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to BDBUS1
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to CAS
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to CKE
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to CLK
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to CS
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to DQ[15]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to DQ[14]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to DQ[13]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to DQ[12]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to DQ[11]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to DQ[10]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to DQ[9]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to DQ[8]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to DQ[7]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to DQ[6]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to DQ[5]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to DQ[4]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to DQ[3]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to DQ[2]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to DQ[1]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to DQ[0]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to DQM[1]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to DQM[0]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to RAS
	set_location_assignment PIN_V13 -to A[3]
	set_location_assignment PIN_V12 -to A[2]
	set_location_assignment PIN_U12 -to A[1]
	set_location_assignment PIN_R13 -to A[0]
	set_location_assignment PIN_N13 -to BA[1]
	set_location_assignment PIN_T12 -to BA[0]
	set_location_assignment PIN_P16 -to CLK
	set_location_assignment PIN_E18 -to BDBUS0
	set_location_assignment PIN_T14 -to CKE
	set_location_assignment PIN_M14 -to CAS
	set_location_assignment PIN_F16 -to BDBUS1
	set_location_assignment PIN_L13 -to CS
	set_location_assignment PIN_U9 -to DQ[15]
	set_location_assignment PIN_V10 -to DQ[14]
	set_location_assignment PIN_T9 -to DQ[13]
	set_location_assignment PIN_R11 -to DQ[12]
	set_location_assignment PIN_R9 -to DQ[11]
	set_location_assignment PIN_T11 -to DQ[10]
	set_location_assignment PIN_P9 -to DQ[9]
	set_location_assignment PIN_P10 -to DQ[8]
	set_location_assignment PIN_U8 -to DQ[7]
	set_location_assignment PIN_V8 -to DQ[6]
	set_location_assignment PIN_T5 -to DQ[5]
	set_location_assignment PIN_V7 -to DQ[4]
	set_location_assignment PIN_U5 -to DQ[3]
	set_location_assignment PIN_V6 -to DQ[2]
	set_location_assignment PIN_T4 -to DQ[1]
	set_location_assignment PIN_U4 -to DQ[0]
	set_location_assignment PIN_U14 -to DQM[1]
	set_location_assignment PIN_U13 -to DQM[0]
	set_location_assignment PIN_P13 -to RAS
	set_location_assignment PIN_N12 -to WE
	set_instance_assignment -name PARTITION_HIERARCHY root_partition -to | -section_id Top

	# Commit assignments
	export_assignments

	# Close project
	if {$need_to_close_project} {
		project_close
	}
}

